﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GeneratorLib;
using System.IO;
using System.Threading;

namespace Generator
{
    class Program
    {
        public static Dictionary<string, Vez> NejlepsiVeze = new Dictionary<string, Vez>();
        public static DateTime StartTime;
        static List<Thread> _threadPool = new List<Thread>();
        public static bool Run = true;

        static void Main(string[] args)
        {
            if (args.Length == 0)
            {
                Console.WriteLine("Prvni argument musi byt adresar s .in soubory");
                Console.ReadLine();
                return;
            }

            DirectoryInfo dir = new DirectoryInfo(args[0]);

            StartTime = DateTime.Now;
            foreach (var soubor in dir.GetFiles("*.in"))
            {
                var zadani = new ZadaniVeze(soubor.FullName) ;
                var t = new Thread(()=>RepeatGenerovat(zadani));
                _threadPool.Add(t);
                t.Start();
            }

            Console.ReadLine();
            Run = false;
        }

        public static void RepeatGenerovat(ZadaniVeze zadani)
        {
            while (Run)
            {
                Generovat(zadani);
            }
        }

        public static void Generovat(ZadaniVeze zadani) 
        {
            zadani = new ZadaniVeze(zadani.Cesta);

            var novaVez = Geneartor.Postav(zadani);

            bool nastav = false;

            if (NejlepsiVeze.ContainsKey(zadani.Cesta))
            {
                if (novaVez.Vyska > NejlepsiVeze[zadani.Cesta].Vyska) nastav = true;
            }
            else nastav = true;

            if (nastav)
            {
                NejlepsiVeze[zadani.Cesta] = novaVez;
                Console.WriteLine("Nova nejlepsi vez pro soubor {0}",zadani.Cesta);

                FileInfo fi = new FileInfo(zadani.Cesta);
                var saveName = fi.FullName.Substring(0, (int)fi.FullName.Length - 2) + "05";
                File.WriteAllText(saveName, novaVez.Serialize());
            }

            Console.WriteLine("Pokud chcete program zastavit zmacknete libovolnou klavesu. {0} dokonceno",zadani.Cesta);
        }
    }
}
