﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GeneratorLib
{
    public static class Geneartor
    {
        public static Random Random = new Random();
        public static Dictionary<string, string[]> ReadBuffer = new Dictionary<string, string[]>();

        public static Vez Postav(ZadaniVeze zadani)
        {
            Vez v = new Vez(zadani);

            UmisteniKostky[] posledniPatro = new UmisteniKostky[1];

            int p = 1;
            List<UmisteniKostky> kostky = new List<UmisteniKostky>();
            while (true)
            {
                try
                {
                    UmisteniKostky[] patro;
                    if (p == 1)
                    {
                        switch (zadani.Typ)
                        {
                            case "D": posledniPatro = PostavPatroPlne(v, p); break;
                            case "DB": posledniPatro = PostavPatroPlne(v, p, true); break;
                            case "P": posledniPatro = PostavPatroPlne(v, p); break;
                            case "PB": posledniPatro = PostavPatroPlne(v, p, true); break;
                            default:
                                throw new ArgumentOutOfRangeException();
                        }

                        p++;
                    }
                    else
                    {
                        switch (zadani.Typ)
                        {
                            case "D": patro = PostavPatroDute(v, p); break;
                            case "DB": patro = PostavPatroDute(v, p, true); break;
                            case "P": patro = PostavPatroPlne(v, p); break;
                            case "PB": patro = PostavPatroPlne(v, p, true); break;
                            default:
                                throw new ArgumentOutOfRangeException();
                        }

                        kostky.AddRange(patro);
                        p++;
                    }


                }
                catch (ArgumentNullException)
                {
                    break;
                }
            }

            kostky.AddRange(posledniPatro);

            v.Kostky = kostky;
            v.Vyska = p;


            return v;
        }

        public static UmisteniKostky[] PostavPatroDute(Vez v, int patro, bool b = false)
        {
            List<UmisteniKostky> l = new List<UmisteniKostky>();
            bool[,] obsazeno = new bool[v.Zadani.X, v.Zadani.Y];

            for (int x = 0; x < obsazeno.GetLength(0); x++)
            {
                for (int y = 0; y < obsazeno.GetLength(1); y++)
                {
                    if (y != 0 && y != obsazeno.GetLength(1)-1 && x != 0 && x != obsazeno.GetLength(0)-1) continue;
                    if (obsazeno[x, y]) continue;

                    int pokus = 0;
                    while (pokus < 100)
                    {
                        var kostka = RKostka(v);

                        if (VejdeSe(obsazeno, kostka, x, y))
                        {
                            if (b && MaSpatnehoSouseda(kostka, l, v, x, y, patro)) continue;

                            l.Add(new UmisteniKostky() { Patro = patro, X = x, Y = y, Barva = kostka.Barva, Rozmery = string.Format("{0}X{1}", kostka.X, kostka.Y) });
                            PridejKostku(ref obsazeno, kostka, x, y);
                            v.Zadani.Kostky.First(kos => kos == kostka).Pocet--;
                            break;
                        }
                        pokus++;
                    }
                    if (pokus == 100) throw new ArgumentNullException();
                }
            }

            return l.ToArray();
        }

        public static UmisteniKostky[] PostavPatroPlne(Vez v,int patro,bool b = false)
        {
            List<UmisteniKostky> l = new List<UmisteniKostky>();
            bool[,] obsazeno = new bool[v.Zadani.X, v.Zadani.Y];

            for (int x = 0; x < obsazeno.GetLength(0); x++)
            {
                for (int y = 0; y < obsazeno.GetLength(1); y++)
                {
                    if (obsazeno[x, y]) continue;

                    int pokus = 0;
                    while (pokus < 100)
                    {
                        var kostka = RKostka(v);

                        if (VejdeSe(obsazeno, kostka, x, y))
                        {
                            if(b && MaSpatnehoSouseda(kostka,l,v,x,y,patro))continue;

                            l.Add(new UmisteniKostky() { Patro = patro, X = x, Y = y, Barva = kostka.Barva, Rozmery = string.Format("{0}X{1}", kostka.X, kostka.Y) });
                            PridejKostku(ref obsazeno, kostka, x, y);
                            v.Zadani.Kostky.First(kos => kos == kostka).Pocet--;
                            break;
                        }
                        pokus++;
                    }
                    if(pokus == 100)throw new ArgumentNullException(); 
                }
            }

            return l.ToArray();
        }

        public static bool MaSpatnehoSouseda(Kostka k, List<UmisteniKostky> umisteni, Vez v, int px, int py, int patro)
        {
            return false;
        }

        public static Kostka RKostka(Vez v)
        {
            var kos = v.Zadani.Kostky.Where(k => k.Pocet > 0).ToArray();
            if (kos.Length == 0) throw new ArgumentNullException("Nejsou kostky");
            return kos[Random.Next(0, kos.Length)];
        }

        public static bool VejdeSe(bool[,] patro, Kostka k, int sx, int sy)
        {
            try
            {
                for (int x = sx; x < sx + k.X; x++)
                {
                    for (int y = sy; y < sy + k.Y; y++)
                    {
                        if (patro[x, y]) return false;
                    }
                }
                return true;
            }
            catch (IndexOutOfRangeException) { return false; }
        }

        public static void PridejKostku(ref bool[,] patro, Kostka k, int sx, int sy)
        {
            for (int x = sx; x < sx + k.X; x++)
            {
                for (int y = sy; y < sy + k.Y; y++)
                {
                    patro[x, y] = true;
                }
            }
        }
    }
}
