﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GeneratorLib
{
    public class Vez
    {
        public ZadaniVeze Zadani;
        public int Vyska;
        public List<UmisteniKostky> Kostky = new List<UmisteniKostky>();

        public Vez(ZadaniVeze zadani)
        {
            Zadani = zadani;
            Kostky = new List<UmisteniKostky>();
        }

        public Vez(string[] lines)
        {
            //Zadani =  new ZadaniVeze(lines.First());
            Kostky = lines.Where(l=>!String.IsNullOrWhiteSpace(l)).Skip(1).Select(l => new UmisteniKostky(l)).ToList() ;
            Vyska = Kostky.OrderBy(k => k.Patro).Last().Patro;
        }

        public string Serialize()
        {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine(Zadani.ToString());

            foreach (var kostka in Kostky)
            {
                sb.AppendLine(kostka.ToString());
            }

            return sb.ToString();
        }
    }

    public struct UmisteniKostky
    {
        public int Patro;
        public int X;
        public int Y;
        public string Barva;
        public string Rozmery;

        public int VelikostX;
        public int VelikostY;

        public UmisteniKostky(string stuff)
        {
            var splat = stuff.Split(' ').Where(s=>!string.IsNullOrWhiteSpace(s)).ToArray();

            Patro = int.Parse(splat[0]);
            X = int.Parse(splat[1]);
            Y = int.Parse(splat[2]);

            Barva = splat[3];
            Rozmery = splat[4];

            var spl = Rozmery.ToUpper().Split('X');
            VelikostX = int.Parse(spl[0]);
            VelikostY = int.Parse(spl[1]);
        }

        public override string ToString()
        {
            return string.Format("{0} {1} {2} {3} {4}", Patro, X + 1, Y + 1, Barva, Rozmery);
        }
    }
}
